Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_DEV_IO Class Reference

Read/Write operations on Devices. More...

`#include <DEV_IO.h>`

Inheritance diagram for ACE_DEV_IO:

[legend]
Collaboration diagram for ACE_DEV_IO:

[legend]
List of all members.

## Public Types
typedef ACE_DEV_Addr | PEER_ADDR
## Public Methods
| ACE_DEV_IO (void)
| Default constructor. More...
ssize_t | send (const void *buf, size_t n) const
| send upto <n> bytes in <buf>. More...
ssize_t | recv (void *buf, size_t n) const
| Recv upto <n> bytes in <buf>. More...
ssize_t | send_n (const void *buf, size_t n) const
| Send n bytes, keep trying until n are sent. More...
ssize_t | recv_n (void *buf, size_t n) const
| Recv n bytes, keep trying until n are received. More...
ssize_t | send (const iovec iov[], size_t n) const
| Send iovecs via <writev>. More...
ssize_t | recv (iovec iov[], size_t n) const
| Recv iovecs via <readv>. More...
ssize_t | send (size_t n,...) const
| Send N char *ptrs and int lengths. More...
ssize_t | recv (size_t n,...) const
| This is an interface to readv, that doesn't use the struct iovec explicitly. More...
ssize_t | send (const void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Send <n> bytes via Win32 WriteFile using overlapped I/O. More...
ssize_t | recv (void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Recv <n> bytes via Win32 ReadFile using overlapped I/O. More...
void | dump (void) const
| Dump the state of an object. More...
int | get_local_addr (ACE_DEV_Addr &) const
| Return the local endpoint address. More...
int | get_remote_addr (ACE_DEV_Addr &) const
| Return the address of the remotely connected peer (if there is one). More...
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...
## Private Attributes
ACE_DEV_Addr | addr_
| Address of device we are connected to. More...
## Friends
class | ACE_DEV_Connector

## Detailed Description

Read/Write operations on Devices.

## Member Typedef Documentation

typedef ACE_DEV_Addr ACE_DEV_IO::PEER_ADDR

## Constructor & Destructor Documentation

ACE_DEV_IO::ACE_DEV_IO | ( | void |  | ) |

| Default constructor.

## Member Function Documentation

void ACE_DEV_IO::dump | ( | void |  | ) | const

| Dump the state of an object. Reimplemented from ACE_DEV.

int ACE_DEV_IO::get_local_addr | ( | ACE_DEV_Addr & | addr | ) | const

| Return the local endpoint address.

int ACE_DEV_IO::get_remote_addr | ( | ACE_DEV_Addr & | addr | ) | const

| Return the address of the remotely connected peer (if there is one).

ASYS_INLINE ssize_t ACE_DEV_IO::recv | ( | void * | buf,
|  | size_t | n,
|  | ACE_OVERLAPPED * | overlapped
| ) | const

| Recv <n> bytes via Win32 ReadFile using overlapped I/O.

ssize_t ACE_DEV_IO::recv | ( | size_t | n,
|  | ... |
| ) | const

| This is an interface to readv, that doesn't use the struct iovec explicitly. The ... can be passed as an arbitrary number of (char *ptr, int len) tuples. However, the count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_DEV_IO::recv | ( | iovec | iov[],
|  | size_t | n
| ) | const

| Recv iovecs via <readv>.

ASYS_INLINE ssize_t ACE_DEV_IO::recv | ( | void * | buf,
|  | size_t | n
| ) | const

| Recv upto <n> bytes in <buf>.

ASYS_INLINE ssize_t ACE_DEV_IO::recv_n | ( | void * | buf,
|  | size_t | n
| ) | const

| Recv n bytes, keep trying until n are received.

ASYS_INLINE ssize_t ACE_DEV_IO::send | ( | const void * | buf,
|  | size_t | n,
|  | ACE_OVERLAPPED * | overlapped
| ) | const

| Send <n> bytes via Win32 WriteFile using overlapped I/O.

ssize_t ACE_DEV_IO::send | ( | size_t | n,
|  | ... |
| ) | const

| Send N char *ptrs and int lengths. Note that the char *'s precede the ints (basically, an varargs version of writev). The count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_DEV_IO::send | ( | const iovec | iov[],
|  | size_t | n
| ) | const

| Send iovecs via <writev>.

ASYS_INLINE ssize_t ACE_DEV_IO::send | ( | const void * | buf,
|  | size_t | n
| ) | const

| send upto <n> bytes in <buf>.

ASYS_INLINE ssize_t ACE_DEV_IO::send_n | ( | const void * | buf,
|  | size_t | n
| ) | const

| Send n bytes, keep trying until n are sent.

## Friends And Related Function Documentation

friend class ACE_DEV_Connector`[friend]`

## Member Data Documentation

ACE_DEV_IO::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks. Reimplemented from ACE_DEV.

ACE_DEV_Addr ACE_DEV_IO::addr_`[private]`

| Address of device we are connected to.

The documentation for this class was generated from the following files:

- DEV_IO.h
- DEV_IO.cpp
- DEV_IO.i